# TAM
A teaching assistant management system to recruit and manage TAs.

## Requirements
* Java 17+
* [Labracore](https://gitlab.ewi.tudelft.nl/eip/labrador/labracore)

## Project Setup
In order to have the project setup properly for development a few steps need to be taken.

1. First the config file should be moved from the template into the actual properties file
   by executing cp src/main/resources/application.template.yaml src/main/resources/application.yaml
   from the root directory of the project.
2. Follow these [instructions](./CONTRIBUTING.md) to submit your work
3. Follow the instructions below to run the website (via CLI or IDE)

### Run website from IDE

1. Install [IntelliJ IDEA Professional](https://www.jetbrains.com/idea/) ([free for students](https://www.jetbrains.com/student/))
2. For IntelliJ to run the project make sure are running jdk 17.
3. Start the project by right-clicking `TAMApplication` and clicking 'Run'
4. Ensure you have [Labracore](https://gitlab.ewi.tudelft.nl/eip/labrador/labracore) running
5. Visit http://localhost:8085/

### Run website from CLI

1. `gradle build`
2. Ensure you have [Labracore](https://gitlab.ewi.tudelft.nl/eip/labrador/labracore) running
3. `sudo java -jar build/libs/tam-2.0.0.jar`
4. Visit http://localhost:8085/
