/*
 * TAM
 * Copyright (C) 2021 - Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package nl.tudelft.tam.cache;

import java.util.List;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.context.annotation.RequestScope;

import nl.tudelft.labracore.api.EditionControllerApi;
import nl.tudelft.labracore.api.dto.EditionDetailsDTO;

@Component
@RequestScope
public class EditionCacheManager extends CoreCacheManager<Long, EditionDetailsDTO> {

	@Autowired
	private ModelMapper mapper;

	@Autowired
	private EditionControllerApi api;

	@Autowired
	private RoleCacheManager roleCache;

	@Override
	protected List<EditionDetailsDTO> fetch(List<Long> ids) {
		return api.getEditionsById(ids).collectList().block();
	}

	@Override
	protected Long getId(EditionDetailsDTO dto) {
		return dto.getId();
	}

}
