/*
 * TAM
 * Copyright (C) 2021 - Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package nl.tudelft.tam.dto.create;

import java.util.*;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import nl.tudelft.labracore.api.dto.EditionCreateDTO;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class MissingEditionsJobOfferImportDTO {
	private Set<Integer> include = new HashSet<>();
	private List<EditionCreateDTO> editions = new ArrayList<>();
	private List<JobOfferCreateDTO> jobOffers = new ArrayList<>();

	public Map<EditionCreateDTO, List<JobOfferCreateDTO>> getIncludedEditions() {
		Map<EditionCreateDTO, List<JobOfferCreateDTO>> included = new HashMap<>();
		for (int i = 0; i < editions.size(); i++) {
			if (include.contains(i)) {
				long id = i;
				included.put(editions.get(i),
						jobOffers.stream().filter(o -> o.getEditionId() == id).toList());
			}
		}
		return included;
	}
}
