/*
 * TAM
 * Copyright (C) 2021 - Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package nl.tudelft.tam.dto.id;

import org.springframework.data.repository.CrudRepository;

import nl.tudelft.librador.dto.id.IdDTO;
import nl.tudelft.tam.model.Profile;
import nl.tudelft.tam.repository.ProfileRepository;

public class ProfileIdDTO extends IdDTO<Profile, Long> {

	public ProfileIdDTO() {
		super(-1L);
	}

	public ProfileIdDTO(Long aLong) {
		super(aLong);
	}

	@Override
	public Class<? extends CrudRepository<Profile, Long>> repositoryClass() {
		return ProfileRepository.class;
	}

	@Override
	public Class<? extends Profile> targetClass() {
		return Profile.class;
	}
}
