/*
 * TAM
 * Copyright (C) 2021 - Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package nl.tudelft.tam.enums;

public enum PayScale {

	SA1(
		"<60 EC", 1
	),
	SA2(
		"60+ EC", 2
	),
	SA3(
		"120+ EC", 3
	),
	SA4(
		"180+ EC / Master", 4
	);

	private final String description;

	private final int level;

	PayScale(String description, int level) {
		this.description = description;
		this.level = level;
	}

	public String detailedString() {
		return this + " (" + description + ")";
	}

	public boolean isHigherThan(PayScale that) {
		return this.level > that.level;
	}
}
