/*
 * TAM
 * Copyright (C) 2021 - Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package nl.tudelft.tam.model;

import javax.persistence.*;

import lombok.*;
import nl.tudelft.tam.model.embeddables.ExtraWorkDefault;
import nl.tudelft.tam.model.embeddables.JobOfferDefault;

@Data
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CoordinatorDefault {

	@Id
	@NonNull
	private Long programId;

	@Embedded
	@AttributeOverrides({
			@AttributeOverride(name = "applicationDeadline", column = @Column(name = "jo_application_deadline", columnDefinition = "DATE")),
			@AttributeOverride(name = "contractName", column = @Column(name = "jo_contract_name")),
			@AttributeOverride(name = "contractBaanCode", column = @Column(name = "jo_contract_baan_code")),
			@AttributeOverride(name = "contractStartDate", column = @Column(name = "jo_contract_start_date", columnDefinition = "DATE")),
			@AttributeOverride(name = "contractEndDate", column = @Column(name = "jo_contract_end_date", columnDefinition = "DATE")),
			@AttributeOverride(name = "description", column = @Column(name = "jo_description")),
			@AttributeOverride(name = "hiringMessage", column = @Column(name = "jo_hiring_message")),
			@AttributeOverride(name = "rejectMessage", column = @Column(name = "jo_reject_message"))
	})
	private JobOfferDefault jobOfferDefault;

	@Embedded
	@AttributeOverrides({
			@AttributeOverride(name = "contractName", column = @Column(name = "ew_contract_name")),
			@AttributeOverride(name = "contractBaanCode", column = @Column(name = "ew_contract_baan_code")),
			@AttributeOverride(name = "declarationDeadline", column = @Column(name = "ew_declaration_deadline", columnDefinition = "DATE"))
	})
	private ExtraWorkDefault extraWorkDefault;

	private String coordinatorContractName;

	private String coordinatorContractEmail;

}
