--
-- TAM
-- Copyright (C) 2021 - Delft University of Technology
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Affero General Public License as
-- published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Affero General Public License for more details.
--
-- You should have received a copy of the GNU Affero General Public License
-- along with this program.  If not, see <https://www.gnu.org/licenses/>.
--

-- TAM
-- Copyright (C) 2021 - Delft University of Technology
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Affero General Public License as
-- published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Affero General Public License for more details.
--
-- You should have received a copy of the GNU Affero General Public License
-- along with this program.  If not, see <https://www.gnu.org/licenses/>.
--

CREATE ALIAS IF NOT EXISTS APFROMDATES AS $$
int APFROMDATES(java.time.LocalDate start, java.time.LocalDate end) {

    java.time.MonthDay q1_start_date = java.time.MonthDay.of(java.time.Month.SEPTEMBER, 1);
    java.time.MonthDay q1_end_date = java.time.MonthDay.of(java.time.Month.NOVEMBER, 10);
    java.time.MonthDay q2_start_date = java.time.MonthDay.of(java.time.Month.NOVEMBER, 11);
    java.time.MonthDay q2_end_date = java.time.MonthDay.of(java.time.Month.FEBRUARY, 5);
    java.time.MonthDay q3_start_date = java.time.MonthDay.of(java.time.Month.FEBRUARY, 6);
    java.time.MonthDay q3_end_date = java.time.MonthDay.of(java.time.Month.APRIL, 20);
    java.time.MonthDay q4_start_date = java.time.MonthDay.of(java.time.Month.APRIL, 21);
    java.time.MonthDay q4_end_date = java.time.MonthDay.of(java.time.Month.JUNE, 30);
    java.time.MonthDay s1_start_date = java.time.MonthDay.of(java.time.Month.SEPTEMBER, 1);
    java.time.MonthDay s1_end_date = java.time.MonthDay.of(java.time.Month.FEBRUARY, 5);

    java.time.LocalDate midpoint = java.time.LocalDate.ofEpochDay((start.toEpochDay() + end.toEpochDay()) / 2L);
    java.time.MonthDay midpointMonthDay = java.time.MonthDay.of(midpoint.getMonth(), midpoint.getDayOfMonth());
    int numberOfDays = start.until(end).getDays();

    if (numberOfDays > 300) {
        return 7;
    } else if (numberOfDays > 150) {
        if (midpointMonthDay.isAfter(s1_start_date) && midpointMonthDay.isBefore(s1_end_date)) {
            return 5;
        }
        return 6;
    }

    if (midpointMonthDay.isAfter(q1_start_date) && midpointMonthDay.isBefore(q1_end_date)) {
        return 0;
    } else if (midpointMonthDay.isAfter(q2_start_date) && midpointMonthDay.isBefore(q2_end_date)) {
        return 1;
    } else if (midpointMonthDay.isAfter(q3_start_date) && midpointMonthDay.isBefore(q3_end_date)) {
        return 2;
    } else if (midpointMonthDay.isAfter(q4_start_date) && midpointMonthDay.isBefore(q4_end_date)) {
        return 3;
    } else {
        return 4;
    }
}
$$;
