--
-- TAM
-- Copyright (C) 2021 - Delft University of Technology
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Affero General Public License as
-- published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Affero General Public License for more details.
--
-- You should have received a copy of the GNU Affero General Public License
-- along with this program.  If not, see <https://www.gnu.org/licenses/>.
--

CREATE FUNCTION APFROMDATES(start_date DATE, end_date DATE)
    RETURNS INT
    DETERMINISTIC
BEGIN
    SET @midpoint = DATE_ADD(start_date, INTERVAL (DATEDIFF(end_date, start_date) DIV 2) DAY);
    SET @number_of_days = DATEDIFF(end_date, start_date);

    SET @q1_start_date = CONCAT(YEAR(NOW()), '09-01');
    SET @q1_end_date = CONCAT(YEAR(NOW()), '11-10');
    SET @q2_start_date = CONCAT(YEAR(NOW()), '11-11');
    SET @q2_end_date = CONCAT(YEAR(NOW()) + 1, '02-05');
    SET @q3_start_date = CONCAT(YEAR(NOW()) + 1, '02-06');
    SET @q3_end_date = CONCAT(YEAR(NOW()) + 1, '04-20');
    SET @q4_start_date = CONCAT(YEAR(NOW()) + 1, '04-21');
    SET @q4_end_date = CONCAT(YEAR(NOW()) + 1, '06-30');
    SET @s1_start_date = CONCAT(YEAR(NOW()), '09-01');
    SET @s1_end_date = CONCAT(YEAR(NOW()) + 1, '02-05');

    IF @number_of_days > 300 THEN
        RETURN 7;
    ELSEIF @number_of_days > 150 THEN
        IF @midpoint_month_day > @s1_start_date AND @midpoint_month_day < @s1_end_date THEN
            RETURN 5;
        END IF;
        RETURN 6;
    END IF;

    IF @midpoint_month_day > @q1_start_date AND @midpoint_month_day < @q1_end_date THEN
        RETURN 0;
    ELSEIF @midpoint_month_day > @q2_start_date AND @midpoint_month_day < @q2_end_date THEN
        RETURN 1;
    ELSEIF @midpoint_month_day > @q3_start_date AND @midpoint_month_day < @q3_end_date THEN
        RETURN 2;
    ELSEIF @midpoint_month_day > @q4_start_date AND @midpoint_month_day < @q4_end_date THEN
        RETURN 3;
    ELSE
        RETURN 4;
    END IF;
END;