--
-- TAM
-- Copyright (C) 2021 - Delft University of Technology
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Affero General Public License as
-- published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Affero General Public License for more details.
--
-- You should have received a copy of the GNU Affero General Public License
-- along with this program.  If not, see <https://www.gnu.org/licenses/>.
--

-- TAM
-- Copyright (C) 2021 - Delft University of Technology
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU Affero General Public License as
-- published by the Free Software Foundation, either version 3 of the
-- License, or (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU Affero General Public License for more details.
--
-- You should have received a copy of the GNU Affero General Public License
-- along with this program.  If not, see <https://www.gnu.org/licenses/>.
--

CREATE OR REPLACE FUNCTION APFROMDATES(start_date DATE, end_date DATE)
    RETURNS INTEGER
AS $$
DECLARE
    midpoint DATE;
    number_of_days INTEGER;
    q1_start_date DATE;
    q1_end_date DATE;
    q2_start_date DATE;
    q2_end_date DATE;
    q3_start_date DATE;
    q3_end_date DATE;
    q4_start_date DATE;
    q4_end_date DATE;
    s1_start_date DATE;
    s1_end_date DATE;
BEGIN
    midpoint := start_date + ((end_date - start_date) / 2);
    number_of_days := end_date - start_date;

    q1_start_date := (DATE_TRUNC('YEAR', NOW()) || '-09-01')::DATE;
    q1_end_date := (DATE_TRUNC('YEAR', NOW()) || '-11-10')::DATE;
    q2_start_date := (DATE_TRUNC('YEAR', NOW()) || '-11-11')::DATE;
    q2_end_date := (DATE_TRUNC('YEAR', NOW()) + INTERVAL '1 YEAR' || '-02-05')::DATE;
    q3_start_date := (DATE_TRUNC('YEAR', NOW()) + INTERVAL '1 YEAR' || '-02-06')::DATE;
    q3_end_date := (DATE_TRUNC('YEAR', NOW()) + INTERVAL '1 YEAR' || '-04-20')::DATE;
    q4_start_date := (DATE_TRUNC('YEAR', NOW()) + INTERVAL '1 YEAR' || '-04-21')::DATE;
    q4_end_date := (DATE_TRUNC('YEAR', NOW()) + INTERVAL '1 YEAR' || '-06-30')::DATE;
    s1_start_date := (DATE_TRUNC('YEAR', NOW()) || '-09-01')::DATE;
    s1_end_date := (DATE_TRUNC('YEAR', NOW()) + INTERVAL '1 YEAR' || '-02-05')::DATE;

    IF number_of_days > 300 THEN
            RETURN 7;
    ELSIF number_of_days > 150 THEN
            IF midpoint >= s1_start_date AND midpoint <= s1_end_date THEN
                RETURN 5;
            END IF;
            RETURN 6;
    END IF;

    IF midpoint >= q1_start_date AND midpoint <= q1_end_date THEN
            RETURN 0;
    ELSIF midpoint >= q2_start_date AND midpoint <= q2_end_date THEN
            RETURN 1;
    ELSIF midpoint >= q3_start_date AND midpoint <= q3_end_date THEN
            RETURN 2;
    ELSIF midpoint >= q4_start_date AND midpoint <= q4_end_date THEN
            RETURN 3;
    ELSE
            RETURN 4;
    END IF;
END;
$$ LANGUAGE plpgsql;
