/*
 * TAM
 * Copyright (C) 2021 - Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package application.dev;

import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.annotation.Import;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.annotation.PropertySources;
import org.springframework.data.jpa.convert.threeten.Jsr310JpaConverters;

import nl.tudelft.labracore.lib.LabracoreApiConfig;
import nl.tudelft.tam.TAMApplication;
import nl.tudelft.tam.test.TestUserDetailsService;

@SpringBootApplication
@PropertySources({
		@PropertySource("classpath:application-dev.properties")
})
@EntityScan(basePackageClasses = { TAMApplication.class, Jsr310JpaConverters.class })
@Import({
		LabracoreApiConfig.class,
		TestUserDetailsService.class
})
public class DevTAMApplication extends TAMApplication {
}
