/*
 * TAM
 * Copyright (C) 2021 - Delft University of Technology
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package nl.tudelft.tam.dto.summary;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import nl.tudelft.tam.dto.view.summary.ApplicationStatusSummaryDTO;
import nl.tudelft.tam.enums.Status;

public class ApplicationStatusSummaryDTOTest {

	private final Status offered = Status.OFFERED;
	private final boolean exists = true;

	private ApplicationStatusSummaryDTO appStatSumDto;

	@BeforeEach()
	void setup() {
		appStatSumDto = new ApplicationStatusSummaryDTO(exists, offered);
	}

	@Test
	void existsTest() {
		assertEquals(exists, appStatSumDto.exists());
	}

	@Test
	void getStatusTest() {
		assertEquals(offered, appStatSumDto.getStatus());
	}

}
